"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTranslationQueryField = void 0;
const drupal_feeds_1 = require("./drupal-feeds");
const createTranslationQueryField = ({ actions, schema }, execute) => __awaiter(void 0, void 0, void 0, function* () {
    // Attach new fields to all translatable Drupal types.
    // - translation: retrieve a specific translation
    actions.createTypes((yield (0, drupal_feeds_1.drupalFeeds)(execute))
        .filter((feed) => feed.translatable)
        .map((feed) => schema.buildObjectType({
        name: `Drupal${feed.typeName}`,
        fields: {
            translation: {
                type: `Drupal${feed.typeName}!`,
                args: {
                    langcode: {
                        type: 'String!',
                    },
                },
                resolve: (source, args, context) => __awaiter(void 0, void 0, void 0, function* () {
                    return ((yield context.nodeModel.runQuery({
                        query: {
                            filter: {
                                langcode: { eq: args.langcode },
                                drupalId: { eq: source.drupalId },
                            },
                        },
                        type: source.internal.type,
                        firstOnly: true,
                    })) ||
                        (yield context.nodeModel.runQuery({
                            query: {
                                filter: {
                                    defaultTranslation: { eq: true },
                                    drupalId: { eq: source.drupalId },
                                },
                            },
                            type: source.internal.type,
                            firstOnly: true,
                        })));
                }),
            },
        },
    })));
});
exports.createTranslationQueryField = createTranslationQueryField;
